package com.sun.org.glassfish.gmbal;

import java.lang.annotation.Annotation;
import java.lang.reflect.AnnotatedElement;
import java.util.ResourceBundle;
import javax.management.MBeanServer;
import javax.management.ObjectName;
import java.io.Closeable;

public interface ManagedObjectManager extends Closeable
{
    public abstract void suspendJMXRegistration();
    
    public abstract void resumeJMXRegistration();
    
    public abstract boolean isManagedObject(Object p0);
    
    public abstract GmbalMBean createRoot();
    
    public abstract GmbalMBean createRoot(Object p0);
    
    public abstract GmbalMBean createRoot(Object p0, String p1);
    
    public abstract Object getRoot();
    
    public abstract GmbalMBean register(Object p0, Object p1, String p2);
    
    public abstract GmbalMBean register(Object p0, Object p1);
    
    public abstract GmbalMBean registerAtRoot(Object p0, String p1);
    
    public abstract GmbalMBean registerAtRoot(Object p0);
    
    public abstract void unregister(Object p0);
    
    public abstract ObjectName getObjectName(Object p0);
    
    public abstract AMXClient getAMXClient(Object p0);
    
    public abstract Object getObject(ObjectName p0);
    
    public abstract void stripPrefix(String... p0);
    
    public abstract void stripPackagePrefix();
    
    public abstract String getDomain();
    
    public abstract void setMBeanServer(MBeanServer p0);
    
    public abstract MBeanServer getMBeanServer();
    
    public abstract void setResourceBundle(ResourceBundle p0);
    
    public abstract ResourceBundle getResourceBundle();
    
    public abstract void addAnnotation(AnnotatedElement p0, Annotation p1);
    
    public abstract void setRegistrationDebug(ManagedObjectManager.RegistrationDebugLevel p0);
    
    public abstract void setRuntimeDebug(boolean p0);
    
    public abstract void setTypelibDebug(int p0);
    
    public abstract void setJMXRegistrationDebug(boolean p0);
    
    public abstract String dumpSkeleton(Object p0);
    
    public abstract void suppressDuplicateRootReport(boolean p0);
    
    public enum RegistrationDebugLevel
    {
        NONE, 
        NORMAL, 
        FINE;
    }
}
